/*                          WARNING !                                     */
/* The script contains commands that may lead to the possible data loss.  */
/* If you need to update your table and keep all data please use          */
/* Table Editor to make changes in the target database.                   */
/* Use "Resolve Dependencies" flag in the Field Editor to make changes    */
/* and keep all data.                                                     */

connect 'C:\Logic\Datos\LOGIC_021INTERBASE.gdb' user 'SYSDBA' password 'masterkey';

CREATE DOMAIN DOM_BOOL_I AS CHAR(1) DEFAULT 'F' CHECK  (value in ('F','T',''));

DROP DOMAIN DAT;

CREATE DOMAIN DAT AS DATE;

CREATE TABLE PAGOS_EN_LINEA2 (NUMPIECE INTEGER NOT NULL,
NUMABONNE INTEGER NOT NULL,
CODIGO_PAGO INTEGER NOT NULL,
RECAUDADOR VARCHAR(10),
MONTO PRICE,
TIPO VARCHAR(1),
FECHA_PAGO DATE NOT NULL,
CONSTRAINT PK1_PAGOS_EN_LINEA2 PRIMARY KEY (CODIGO_PAGO),
CONSTRAINT CHECHKTIPO1 CHECK (TIPO IN ('R','P'))
);

/* Datos Generales de Clientes (abonados)  */
ALTER TABLE ABONNE
DROP VENCELGT,
DROP FECHA_GESTION,
ADD VENCELGT DATE,
ADD FECHA_GESTION DATE
;

/* Lista de Compras de Pelculas  */
ALTER TABLE ABONNEPPV
DROP DTFACT,
ADD DTFACT DATE
;

ALTER TABLE AVERINTERNET
DROP FECHAINI,
DROP FECHAFINAL,
ADD FECHAINI DATE,
ADD FECHAFINAL DATE
;

ALTER TABLE BITACORA_NODOS
DROP FECHA,
ADD FECHA DATE NOT NULL
;

ALTER TABLE CABLEMODEMSERV
DROP FECHAVENCIM,
ADD FECHAVENCIM DATE
;

/* Hoja de Control de diario para consultas externas  */
ALTER TABLE CDDTRCONDI
DROP FECHA,
ADD FECHA DATE
;

/* Almacena los lotes de desconexiones del da  */
ALTER TABLE DECOLUNES
DROP DTSAISIE,
ADD DTSAISIE DATE
;

ALTER TABLE DEPOSITOS
DROP FECHA,
ADD FECHA DATE
;

ALTER TABLE DICO
DROP CREATEDATE,
DROP LASTUPDATE,
ADD CREATEDATE DATE,
ADD LASTUPDATE DATE
;

/* Contiene lineas de contabilidad  */
ALTER TABLE ECRITCPT
DROP FECHA_DESDE,
DROP FECHA_HASTA,
ADD FECHA_DESDE DATE,
ADD FECHA_HASTA DATE
;

ALTER TABLE ESTCTA_031
DROP ULT_PAGO,
ADD ULT_PAGO DATE
;

/* Contiene los cheques rechazados  */
ALTER TABLE IMPAYE
DROP DTPAIE,
ADD DTPAIE DATE
;

/* Contiene informacion de Internet para el cliente  */
ALTER TABLE INTERNET
DROP FECHAVENCE,
ADD FECHAVENCE DATE
;

/* Contiene informacion acerca de vendedores, tecnicos y cobradores  */
ALTER TABLE INTERVENANT
ADD CLAVE VARCHAR(10),
ADD COMISION FLOAT,
ADD COBRA DOM_BOOL DEFAULT 'F',
ADD ENLINEA DOM_BOOL DEFAULT 'F'
;

/* Contiene informacin acerca de ordenes de trabajo  */
ALTER TABLE INTERVENTION
DROP DTOTAVERIA,
DROP ROLLINICIAL,
DROP ROLLFINAL,
DROP FECH_CHG_GRUPO,
ADD DTOTAVERIA DATE,
ADD ROLLINICIAL DATE,
ADD ROLLFINAL DATE,
ADD FECH_CHG_GRUPO DATE
;

ALTER TABLE LOGRELOJ
DROP FECHA,
ADD FECHA DATE
;

ALTER TABLE LOTE_DESC_RACSA
DROP FECHA_CARGA,
DROP FECHA_DESCO,
ADD FECHA_CARGA DATE,
ADD FECHA_DESCO DATE
;

ALTER TABLE LOTE_RECO_RACSA
DROP FECHA_CARGA,
DROP FECHA_RECO,
ADD FECHA_CARGA DATE,
ADD FECHA_RECO DATE
;

/*    */
ALTER TABLE NODE
DROP FECHA_INIC,
DROP FECHA_FINC,
DROP FECHA_ENLACE,
ADD FECHA_INIC DATE,
ADD FECHA_FINC DATE,
ADD FECHA_ENLACE DATE
;

ALTER TABLE PAGOS_EN_LINEA
DROP FECHA_PAGO,
ADD FECHA_PAGO DATE NOT NULL
;

/* Contiene lista de Servicios que pueden ser facturados  */
ALTER TABLE PRODUIT
DROP DTDEB,
DROP DTFIN,
ADD DTDEB DATE,
ADD DTFIN DATE
;

ALTER TABLE SALDOS_PENDIENTES
DROP FECHA,
ADD FECHA DATE NOT NULL
;

/* Contiene calendario de las peliculas PPV  */
ALTER TABLE SCHEDULEPPV
DROP SCHEDSTARTDT,
DROP DTSAISIE,
ADD SCHEDSTARTDT DATE,
ADD DTSAISIE DATE
;

ALTER TABLE SOLICITUD_CABIO_PRECIO
DROP FECHA_SOLICITUD,
DROP FEHA_APLICACION,
DROP FECHA_APROBACION,
ADD FECHA_SOLICITUD DATE NOT NULL,
ADD FEHA_APLICACION DATE,
ADD FECHA_APROBACION DATE
;

ALTER TABLE TEMPCOMPARAINTERNET
DROP FECHA,
ADD FECHA DATE
;

/* Contiene informacion de terminales (premium y DLA)  */
ALTER TABLE TERMINAL
DROP FECHAVENCE,
ADD FECHAVENCE DATE,
ADD HUB CHAR(1)
;

/* Detalle de pelculas disponibles en PPV  */
ALTER TABLE TITLEPPV
DROP DTSAISIE,
ADD DTSAISIE DATE
;

/* Tabla de Personas con acceso al programa  */
ALTER TABLE UTILISATEUR
DROP FECHASALIDA,
ADD FECHASALIDA DATE
;

/* Guarda Los registros de venta para los clientes. Se actualiza en la fecha con cada cambio que se haga.  */
ALTER TABLE VENTE
DROP DTRESI2,
ADD DTRESI2 DATE
;

COMMIT work;


CREATE GENERATOR SOLICITUD_CABIO_PRECIO_GEN;

CREATE GENERATOR GEN_PL;

CREATE INDEX BLOCNOTEINDEX2 ON BLOCNOTE(DTSAISIE);

COMMIT WORK;
SET term ^;
CREATE PROCEDURE INC_PL  
RETURNS  (NUM_PAGO INTEGER)
AS
begin
  NUM_PAGO = Gen_Id (GEN_PL,1);
  suspend;
  exit;
end^

CREATE PROCEDURE INC_SOLI_CAMB_PREC  
RETURNS  (IDSOLICITUD INTEGER)
AS
/*
  Procedure: <procedure name>

  Author   : <your name>
  Date     : 28/06/2005 11:36:13 a.m.
  Purpose  :

  Date     :
  Changed  :
*/

/*DECLARE VARIABLE <variable_name> <datatype>; */
BEGIN
  IDSOLICITUD = gen_id(SOLICITUD_CABIO_PRECIO_GEN, 1);
  SUSPEND;
  EXIT;
END^

CREATE PROCEDURE INSERT_PAGOS_LINEA (NUMPIECE INTEGER,NUMABONNE INTEGER,RECAUDADOR VARCHAR(10),MONTO DOUBLE PRECISION,FECHA DATE,TIPO VARCHAR(1)) 
RETURNS  (CODIGO_PAGO INTEGER)
AS
DECLARE VARIABLE cp integer;
BEGIN
  execute procedure INC_PL returning_values :cp;
  insert into PAGOS_EN_LINEA2
  (numpiece,numabonne,codigo_pago,recaudador,monto,fecha_pago,tipo)
  values (:numpiece,:numabonne,:cp,:recaudador,:monto,:fecha,:tipo);
  codigo_pago = cp;
  SUSPEND;
END^

CREATE PROCEDURE INSERT_REVERSION (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10)) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numpiece integer;


begin

execute procedure incEC returning_values :numpiece;

insert into ecritcpt
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp,codope, encaisse, reste, codinsee, typec, cbor, resumanu,
 numlote)
values
(:numpiece, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, 'F', '', :codope, 0 ,:mttdeb, :codinsee, :typec, :cbor, :resumanu,
 :numlote);

numrgt = numpiece;
SUSPEND;

end^

CREATE PROCEDURE NOMBRE_ABONADO (SOCIO INTEGER) 
RETURNS  (NOMBRE VARCHAR(50))
AS
DECLARE VARIABLE N VARCHAR(50);
begin
   FOR SELECT NOM FROM ABONNE WHERE NUMABONNE =:SOCIO INTO N  DO
    NOMBRE = N;
end^

CREATE PROCEDURE SP_DETALLE_PAGO (SOCIO INTEGER,NUMPIECE INTEGER,MONTO DOUBLE PRECISION) 
RETURNS  (Q_SERVICIO INTEGER)
AS
/*
  Procedure:

  Author   :
  Date     :
  Purpose  :
  Params
  ------
  <param>  : <purpose>
*/
declare variable ms double precision;
declare variable q_servicios integer;
declare variable cp varchar(4);
declare variable impuesto varchar(4);
declare variable jv varchar(4);
declare variable jb varchar(4);
declare variable c integer;
declare variable i integer;
declare variable monto_detec double precision;
declare variable monto_relativo double precision;
declare variable monto_total double precision;
begin
     i = 1;
     c = 0;
     monto_relativo = monto;
     monto_total = 0;
     FOR  select distinct vente.codprod,sum(vente.mtt),produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE from vente inner join PRODUIT on vente.CODPROD = produit.CODPROD where vente.DTRESI >= 'TODAY' and vente.STATUT = 'A' and vente.NUMABONNE =:SOCIO GROUP BY VENTE.CODPROD,produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE into :cp,:ms,:impuesto,:jb,:jv  do
     begin
       monto_total = monto_total + ms;
     end
     if (monto <= monto_total) then
     begin
        FOR  select distinct vente.codprod,sum(vente.mtt),produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE from vente inner join PRODUIT on vente.CODPROD = produit.CODPROD where vente.DTRESI >= 'TODAY' and vente.STATUT = 'A' and vente.NUMABONNE =:SOCIO GROUP BY VENTE.CODPROD,produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE into :cp,:ms,:impuesto,:jb,:jv  do
             begin
             if (monto_relativo >= ms) then
                 monto_detec = ms;
             else
             begin
             if (monto_relativo > 0) then
                 monto_detec = monto_relativo;
             else
                 monto_detec = 0;
             end
             insert into DETEC(NUMPIECE,CODPROD,MTT,CODTVA,NUMJRNL,CANTIDAD) VALUES (:NUMPIECE,:cp,:monto_detec,:impuesto,:jv,1);
             monto_detec = 0;
             c = c +1;
             monto_relativo = monto_relativo - ms;
        end
   end
   else/*si el monto es mayor a la suma de los servicios */
  begin
      FOR  select distinct vente.codprod,sum(vente.mtt),produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE from vente inner join PRODUIT on vente.CODPROD = produit.CODPROD where vente.DTRESI >= 'TODAY' and vente.STATUT = 'A' and vente.NUMABONNE =:SOCIO GROUP BY VENTE.CODPROD,produit.CODTVA,produit.JRNLBKE,produit.JRNLVTE into :cp,:ms,:impuesto,:jb,:jv  do
      begin
          if (i = 1) then
          begin
             monto_detec = (monto - monto_total) + ms;
             i = i +1;
          end
          else
          begin
               if (monto_relativo >= ms) then
                 monto_detec = ms;
               else
               begin
                 if (monto_relativo > 0) then
                    monto_detec = monto_relativo;
                 else
                  monto_detec = 0;
                end
          end
          insert into DETEC(NUMPIECE,CODPROD,MTT,CODTVA,NUMJRNL,CANTIDAD) VALUES (:NUMPIECE,:cp,:monto_detec,:impuesto,:jv,1);
             monto_detec = 0;
             c = c +1;
             monto_relativo = monto_relativo - ms;
      end
  end
  Q_SERVICIO = c;
end^

CREATE PROCEDURE VALIDA_REVERSION2 (NUMPIECE INTEGER) 
RETURNS  (MONTO DOUBLE PRECISION)
AS
DECLARE VARIABLE M DOUBLE PRECISION;
/*
Valida que existe un pago para aplicar la correspondiente reversion
si Resultado = P , entoces si se acepta la reversin de lo contrario no
*/
BEGIN
  SELECT monto FROM PAGOS_EN_LINEA2 WHERE NUMPIECE = :NUMPIECE AND TIPO = 'P' INTO M;
  MONTO = M;
  SUSPEND;
END^

ALTER PROCEDURE INSERT_BLOC_NOTE (NUMABONNE INTEGER,LIB VARCHAR(50),DTSAISIE DATE,CODOPE VARCHAR(10))
AS
declare variable numbn integer;

begin

execute procedure incbn returning_values :numbn ;
 
insert into Blocnote 
(numBN, numabonne,lib, dtsaisie,codope) 
values 
(:numbn, :numabonne, :lib, :dtsaisie,:codope);

end^

ALTER PROCEDURE INSERT_BN_INTERNET (NUMLLAMADA INTEGER,NUMABONNE INTEGER,FECHAINI DATE,HORAINI VARCHAR(5),USUARIOINI VARCHAR(10),MOTIVO VARCHAR(4),RESPUESTA VARCHAR(4),OBSERVACION VARCHAR(4096),ESTADO CHAR(1),GRUPOLATE VARCHAR(4)) 
RETURNS  (NUMBINT INTEGER)
AS
declare variable numbnint integer;

begin

execute procedure incbnint returning_values :numbnint ;
 
insert into Averinternet 
(numllamada, numabonne, fechaini, horaini, usuarioini, motivo,respuesta,observacion,estado,grupolate) 
values 
(:numbnint, :numabonne,:fechaini,:horaini,:usuarioini,:motivo,:respuesta,:observacion,:estado,:grupolate);

numbint = numbnint;
SUSPEND;
end^

ALTER PROCEDURE INSERT_BN_INTERNETB (NUMLLAMADA INTEGER,NUMABONNE INTEGER,FECHAINI DATE,HORAINI VARCHAR(5),USUARIOINI VARCHAR(10),MOTIVO VARCHAR(4),RESPUESTA VARCHAR(4),OBSERVACION VARCHAR(4096),ESTADO CHAR(1),GRUPOLATE VARCHAR(4),PRIORIDAD INTEGER) 
RETURNS  (NUMBINT INTEGER)
AS
declare variable numbnint integer;
begin
execute procedure incbnint returning_values :numbnint;
insert into Averinternet
(numllamada, numabonne, fechaini, horaini, usuarioini, motivo,respuesta,observacion,estado,grupolate,prioridad)
values
(:numbnint,:numabonne,:fechaini,:horaini,:usuarioini,:motivo,:respuesta,:observacion,:estado,:grupolate,:prioridad);
numbint = numbnint;
SUSPEND;
end^

ALTER PROCEDURE INSERT_COLILLA (NUMABONNE INTEGER,NUMSOUSCRIPT INTEGER,NOM VARCHAR(50),DTSAISIE DATE,CODOPE VARCHAR(10))
AS
declare variable numcambio integer;

begin

execute procedure inccambio returning_values :numcambio ;

insert into CAMBIOCOLILLA
(numcambio, numabonne, numsouscript, nom, dtsaisie, codope)
values 
(:numcambio, :numabonne, :numsouscript, :nom, :dtsaisie, :codope);

END^

ALTER PROCEDURE INSERT_ECRITCPT_DETEC_F_A (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,LIB VARCHAR(50),MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,CODOPE VARCHAR(10),MDRGLT CHAR(4),CODINSEE CHAR(5),NUMJRNL CHAR(3),RECONCIL CHAR(1),MOTIFIMP CHAR(4),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,CODPROD CHAR(4),CODTVA CHAR(4),JRNLDET CHAR(3)) 
RETURNS  (NUMFACT INTEGER)
AS
declare variable numEC integer;
declare variable encaisse double precision;
declare variable reste double precision;
declare variable mtt double precision;


begin

execute procedure incEC returning_values :numEC ;

encaisse = 0;
 if (mttdeb = 0) then mtt=mttcred;
 if (mttcred =0) then mtt=mttdeb;
 if (typec ='FAC') then reste =mttdeb;
 if (typec ='AVR') then reste = mttCRED;

insert into ECRITCPT 
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp, codope, encaisse, reste, codinsee,
 typec, cbor, resumanu) 
values 
(:numEC, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numEC, :mttdeb,
 :mttcred, :mdrglt, :reconcil, :motifimp, :codope, :encaisse, :reste, :codinsee,
 :typec, :cbor, :resumanu);




insert into DETEC 
(numpiece,codprod, mtt, codtva, numjrnl)
values 
(:numEC, :codprod, :mtt, :codtva, :jrnldet);

numfact = numec;
SUSPEND;
end^

ALTER PROCEDURE INSERT_ECRITCPT_F_A (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,LIB VARCHAR(50),MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,CODOPE VARCHAR(10),MDRGLT CHAR(4),CODINSEE CHAR(5),NUMJRNL CHAR(3),RECONCIL CHAR(1),MOTIFIMP CHAR(4),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER) 
RETURNS  (NUMFACT INTEGER)
AS
declare variable numEC integer;
declare variable encaisse double precision;
declare variable reste double precision;


begin

execute procedure incEC returning_values :numEC ;

encaisse = 0;
 if (typec ='FAC') then reste =mttdeb;
 if (typec ='AVR') then reste = mttCRED;

insert into ECRITCPT 
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp, codope, encaisse, reste, codinsee,
 typec, cbor, resumanu) 
values 
(:numEC, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numEC, :mttdeb,
 :mttcred, :mdrglt, :reconcil, :motifimp, :codope, :encaisse, :reste, :codinsee,
 :typec, :cbor, :resumanu);

numfact = numec;
SUSPEND;
end^

ALTER PROCEDURE INSERT_HISTERMINAL (NUMABONNE INTEGER,NUMSERIE CHAR(15),CODOPE CHAR(10),TIPOMOVIMIENTO CHAR(3),FECHAMOVI DATE,COMMENT VARCHAR(50))
AS
declare variable numHIST integer;

begin

execute procedure inchist returning_values :numhist ;
 
insert into HISTERMINAL
(numHIST, numabonne,numserie,fechamovi, codope,tipomovimiento,comment) 
values 
(:numHIST, :numabonne,:numserie,:fechamovi,:codope,:tipomovimiento,:comment);

end^

ALTER PROCEDURE INSERT_IMPAYE (NUMABONNE INTEGER,NUMPIECE INTEGER,MOTIF CHAR(4),LIB CHAR(25),ESTADO CHAR(1),MTT DOUBLE PRECISION,PERIODE DATE)
AS
declare variable numimp integer;

begin

execute procedure incimp returning_values :numimp ;
 
insert into impaye
(numimp, numabonne,periode,mtt,motif,estado,numpiece,lib)
values 
(:numimp, :numabonne,:periode, :mtt, :motif, :estado, :numpiece, :lib);


SUSPEND;
end^

ALTER PROCEDURE INSERT_INTERVENTION (NUMABONNE INTEGER,NUMRDV INTEGER,DTDEB DATE,HEURE CHAR(5),LIB VARCHAR(25),TIPO CHAR(4),ESTADO CHAR(1),MOTIF CHAR(4),REPONSE CHAR(4),DETMOTIF VARCHAR(50),DETREP VARCHAR(50),OPESAISIE VARCHAR(10),DTOTAVERIA DATE) 
RETURNS  (NUMITV INTEGER)
AS
declare variable numinter integer ;

begin

execute procedure incItv returning_values :numinter ;
 
insert into Intervention 
(numinter, numabonne,dtdeb, heure, lib, tipo,motif,reponse,
 opesaisie,numrdv,detmotif,detrep, dtotaveria, estado) 
values 
(:numinter, :numabonne, :dtdeb, :heure, :lib, :tipo, :motif, :reponse,
 :opesaisie, :numrdv, :detmotif, :detrep, :dtotaveria, :estado);


NUMITV = NUMINTER;
SUSPEND;
end^

ALTER PROCEDURE INSERT_INTERVENTION2 (NUMABONNE INTEGER,NUMRDV INTEGER,DTDEB DATE,HEURE CHAR(5),LIB VARCHAR(25),TIPO CHAR(4),ESTADO CHAR(1),MOTIF CHAR(4),REPONSE CHAR(4),DETMOTIF VARCHAR(50),DETREP VARCHAR(50),OPESAISIE VARCHAR(10),DTOTAVERIA DATE,GRUPOLATE VARCHAR(4)) 
RETURNS  (NUMITV INTEGER)
AS
declare variable numinter integer ;

begin

execute procedure incItv returning_values :numinter ;
 
insert into Intervention 
(numinter, numabonne,dtdeb, heure, lib, tipo,motif,reponse,
 opesaisie,numrdv,detmotif,detrep, dtotaveria, estado, grupolate) 
values 
(:numinter, :numabonne, :dtdeb, :heure, :lib, :tipo, :motif, :reponse,
 :opesaisie, :numrdv, :detmotif, :detrep, :dtotaveria, :estado, :grupolate);


NUMITV = NUMINTER;
SUSPEND;
end^

ALTER PROCEDURE INSERT_RGT_DIRECT (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10)) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numpiece integer;


begin

execute procedure incEC returning_values :numpiece;

insert into ecritcpt
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp,codope, encaisse, reste, codinsee, typec, cbor, resumanu,
 numlote) 
values 
(:numpiece, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, 'F', '', :codope, :mttcred,0, :codinsee, :typec, :cbor, :resumanu,
 :numlote);

numrgt = numpiece;
SUSPEND;

end^

ALTER PROCEDURE INSERT_RGT_DIRECT2 (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10),CODIGODEPAGO INTEGER) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numpiece integer;


begin

execute procedure incEC returning_values :numpiece;

insert into ecritcpt
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp,codope, encaisse, reste, codinsee, typec, cbor, resumanu,
 numlote,codigodepago) 
values 
(:numpiece, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, 'F', '', :codope, :mttcred,0, :codinsee, :typec, :cbor, :resumanu,
 :numlote,:codigodepago);

numrgt = numpiece;
SUSPEND;

end^

ALTER PROCEDURE INSERT_RGT_FROM_TEMPEC (NUMPIECE INTEGER,NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10),MOTIFIMP CHAR(4))
AS
begin

insert into ecritcpt
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp,codope, encaisse, reste, codinsee, typec, cbor, 
resumanu, numlote) 
values 
(:numpiece, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, 'F', :motifimp, :codope, :mttcred,0, :codinsee, :typec, :cbor, :resumanu,
 :numlote);

end^

ALTER PROCEDURE INSERT_ROL (NUMINTER INTEGER,TIPO CHAR(4),DTSAISIE DATE,HRSAISIE CHAR(5),OPESAISIE VARCHAR(10),FECHACITA DATE,HRCITA CHAR(5),OBSERVACION VARCHAR(40),STATUS CHAR(1),CODINT CHAR(4),MOVIL CHAR(6),SECTOR CHAR(1),PADRINO VARCHAR(10))
AS
declare variable numrole integer ;

begin

execute procedure incRole returning_values :numrole ;
 
insert into roles
(numrole, numinter, tipo,dtsaisie, hrsaisie, opesaisie, fechacita,hrcita,
 observacion,status, codint, movil, sector, padrino) 
values 
(:numrole,:numinter, :tipo,:dtsaisie, :hrsaisie, :opesaisie, :fechacita,:hrcita,
 :observacion,:status, :codint, :movil, :sector, :padrino); 

end^

ALTER PROCEDURE INSERT_STAT_RECO (NUMABONNE INTEGER,DTRECO DATE,DTRESI DATE)
AS
declare variable numstatreco integer;

begin

execute procedure incstatreco returning_values :numstatreco ;
 
insert into StatRECO
(numstatreco, numabonne,dtreco,dtresi) 
values 
(:numstatreco, :numabonne,:dtreco,:dtresi);

end^

ALTER PROCEDURE INSERT_TEMPEC (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10),MOTIFIMP CHAR(4),LIBNC VARCHAR(50),NUMCHQ CHAR(10),BANKCHQ CHAR(25)) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numEC integer;


begin

execute procedure incEC returning_values :numEC ;

insert into TEMPEC
(numtemp, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, codope, codinsee, typec, cbor, resumanu, numlote , motifimp, libnc,
 numchq, bankchq) 
values 
(:numEC, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, :codope, :codinsee, :typec, :cbor, :resumanu, :numlote , :motifimp,
 :libnc,:numchq, :bankchq);

numrgt = numec;
SUSPEND;
end^

ALTER PROCEDURE INSERT_TEMPEC_TEMPDETEC (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,CODPROD CHAR(4),CODTVA CHAR(4),JRNLDET CHAR(3),NUMLOTE VARCHAR(10),MOTIFIMP CHAR(4),LIBNC VARCHAR(50),NUMCHQ CHAR(10),BANKCHQ CHAR(25)) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numEC integer;
declare variable mtt double precision;


begin

execute procedure incEC returning_values :numEC ;

if (mttdeb = 0) then mtt=mttcred;
if (mttcred =0) then mtt=mttdeb;

insert into TEMPEC
(numtemp, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, codope, codinsee, typec, cbor, resumanu, numlote , motifimp, libnc,
 numchq, bankchq) 
values 
(:numEC, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, :codope, :codinsee, :typec, :cbor, :resumanu, :numlote , :motifimp,
 :libnc,:numchq, :bankchq);




insert into TEMPDETEC 
(numtemp, codprod, mtt, codtva, numjrnl)
values 
(:numEC, :codprod, :mtt, :codtva, :jrnldet);

numrgt = numec;
SUSPEND;
end^

ALTER PROCEDURE INSERT_TRANSACDLA (DTSAISIE DATE,HEURETRANSAC CHAR(8),OPETRANSAC CHAR(10),ENVOITRANSAC CHAR(250)) 
RETURNS  (NUMTRANSAC INTEGER)
AS
declare variable numtransacdla integer;

begin

execute procedure INCTRANSACDLA returning_values :numtransacdla;
 
insert into TRANSACDLA
(numtransacdla, dtsaisie,heureTransac,envoitransac,opetransac) 
values 
(:numtransacdla, :dtsaisie,:heureTransac,:envoitransac,:opetransac); 


NUMTRANSAC = NUMTRANSACDLA;
SUSPEND;
end^

ALTER PROCEDURE INSERT_VENTE (NUMABONNE INTEGER,CODPROD CHAR(4),DTSAISIE DATE,DTSIGN DATE,MTT DOUBLE PRECISION,MTTDOL DOUBLE PRECISION,CODPROV CHAR(4),CODVEND CHAR(4),CTINST DOUBLE PRECISION,CTREDUC DOUBLE PRECISION,QTEDMD SMALLINT,STATUT CHAR(1)) 
RETURNS  (ORDREVTE INTEGER)
AS
declare variable numordre integer;

begin

execute procedure incvente returning_values :numordre ;
 
insert into Vente 
(ordre, numabonne,codprod, dtsaisie, dtsign, mtt, mttdol, codprov, codvend,
 ctinst, ctreduc,qtedmd,statut) 
values 
(:numordre, :numabonne, :codprod, :dtsaisie, :dtsign, :mtt, :mttdol, :codprov,
 :codvend, :ctinst, :ctreduc,:qtedmd, :statut);

ORDREVTE = NUMORDRE;
SUSPEND;
end^

COMMIT WORK^

